package com.bwie.aspect;

import com.bwie.annotation.Idempotent;
import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.annotation.Around;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

/**
 * 切面进行幂等性实现
 */
public class IdempotentAspect {

    @Around("@annotation(idempotent)")
    public Object independent(ProceedingJoinPoint joinPoint, Idempotent idempotent) {
        Object result=null;
        Map<String,Object> map=new ConcurrentHashMap<String,Object>();
        String id = generateId(joinPoint.getArgs());
        try {
            if (map.containsKey(id)){
                System.out.println("不要重复提交请求");
                return map.get(id);
            }
            result= joinPoint.proceed();
        } catch (Throwable throwable) {
            throwable.printStackTrace();
        }
        map.put(id,result);
        return result;
    }

    private String generateId(Object[] args){
        StringBuilder stringBuilder = new StringBuilder();
        for (Object arg : args) {
            stringBuilder.append(arg.hashCode());
        }
        return stringBuilder.toString();
    }
}
