package com.bwie.service.impl;

import com.bwie.annotation.Idempotent;
import com.bwie.common.LoginRequest;
import com.bwie.common.Result;
import com.bwie.mapper.UserMapper;
import com.bwie.service.UserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class UserServiceImpl implements UserService {
    @Autowired
    private UserMapper userMapper;

    /**
     * |登录
     * @param loginRequest
     * @return
     */
    @Idempotent
    public Result login(LoginRequest loginRequest) {
        LoginRequest loginRequest1 = userMapper.login(loginRequest);
        if (loginRequest1==null){
            return Result.error("账号密码错误");
        }
        return Result.success();
    }
}
